# Brain & Display

The `Brain` class provides access to the VEX V5 brain's built-in components, including the screen, battery, and SD card. This is the central hub for interacting with the robot's onboard hardware.

---

## Brain

::: vex.Brain
    options:
      show_source: false
      heading_level: 2

---

## LCD Display

The `Brain.Lcd` class allows you to draw graphics, print text, and handle touch events on the V5 brain's screen.

::: vex.Brain.Lcd
    options:
      show_source: false
      heading_level: 3

---

## Battery

The `Brain.Battery` class provides information about the V5 brain's battery, such as capacity, voltage, current, and temperature.

::: vex.Brain.Battery
    options:
      show_source: false
      heading_level: 3

---

## SD Card

The `Brain.Sdcard` class allows you to interact with the SD card inserted into the V5 brain, including file operations.

::: vex.Brain.Sdcard
    options:
      show_source: false
      heading_level: 3

---
