# Enums & Units

This page documents all enums and unit types used throughout the DishPy VEX Python SDK. These are used for specifying units, modes, and options for various API calls.

---

## Ports

::: vex.Ports
    options:
      show_source: false
      heading_level: 2

---

## Base Enum

::: vex.vexEnum
    options:
      show_source: false
      heading_level: 2

---

## Units

### PercentUnits

::: vex.PercentUnits
    options:
      show_source: false
      heading_level: 3

### TimeUnits

::: vex.TimeUnits
    options:
      show_source: false
      heading_level: 3

### CurrentUnits

::: vex.CurrentUnits
    options:
      show_source: false
      heading_level: 3

### VoltageUnits

::: vex.VoltageUnits
    options:
      show_source: false
      heading_level: 3

### PowerUnits

::: vex.PowerUnits
    options:
      show_source: false
      heading_level: 3

### TorqueUnits

::: vex.TorqueUnits
    options:
      show_source: false
      heading_level: 3

### RotationUnits

::: vex.RotationUnits
    options:
      show_source: false
      heading_level: 3

### VelocityUnits

::: vex.VelocityUnits
    options:
      show_source: false
      heading_level: 3

### DistanceUnits

::: vex.DistanceUnits
    options:
      show_source: false
      heading_level: 3

### AnalogUnits

::: vex.AnalogUnits
    options:
      show_source: false
      heading_level: 3

### TemperatureUnits

::: vex.TemperatureUnits
    options:
      show_source: false
      heading_level: 3

---

## Device & Control Enums

### DirectionType

::: vex.DirectionType
    options:
      show_source: false
      heading_level: 3

### TurnType

::: vex.TurnType
    options:
      show_source: false
      heading_level: 3

### BrakeType

::: vex.BrakeType
    options:
      show_source: false
      heading_level: 3

### GearSetting

::: vex.GearSetting
    options:
      show_source: false
      heading_level: 3

### FontType

::: vex.FontType
    options:
      show_source: false
      heading_level: 3

### ThreeWireType

::: vex.ThreeWireType
    options:
      show_source: false
      heading_level: 3

### ControllerType

::: vex.ControllerType
    options:
      show_source: false
      heading_level: 3

### AxisType

::: vex.AxisType
    options:
      show_source: false
      heading_level: 3

### OrientationType

::: vex.OrientationType
    options:
      show_source: false
      heading_level: 3

### ObjectSizeType

::: vex.ObjectSizeType
    options:
      show_source: false
      heading_level: 3

### LedStateType

::: vex.LedStateType
    options:
      show_source: false
      heading_level: 3

### GestureType

::: vex.GestureType
    options:
      show_source: false
      heading_level: 3

### VexlinkType

::: vex.VexlinkType
    options:
      show_source: false
      heading_level: 3

### EventMask

::: vex.EventMask
    options:
      show_source: false
      heading_level: 3

---
