# Sensors

This page documents the VEX V5 sensor classes available in the DishPy SDK. Each class provides an interface to a specific VEX sensor, with methods for reading data and controlling sensor behavior.

---

## GPS Sensor

::: vex.Gps

---

## Inertial Sensor

::: vex.Inertial

---

## Rotation Sensor

::: vex.Rotation

---

## Optical Sensor

::: vex.Optical

---

## Distance Sensor

::: vex.Distance

---

## Electromagnet

::: vex.Electromagnet

---

## Accelerometer

::: vex.Accelerometer

---

## Analog Input

::: vex.AnalogIn

---

## Encoder

::: vex.Encoder

---

## Sonar

::: vex.Sonar

---

## PWM

::: vex.Pwm

---

## Servo

::: vex.Servo

---

## Potentiometer

::: vex.Potentiometer

---

## Potentiometer V2

::: vex.PotentiometerV2

---

## Line Sensor

::: vex.Line

---

## Light Sensor

::: vex.Light

---

## Gyro

::: vex.Gyro

---

## Limit Switch

::: vex.Limit

---

## Bumper

::: vex.Bumper

---

## Digital Input

::: vex.DigitalIn

---

## Digital Output

::: vex.DigitalOut

---

## LED

::: vex.Led

---

## Pneumatics

::: vex.Pneumatics

---

## Vision Sensor

::: vex.Vision

---

## Vision Object

::: vex.VisionObject

---

## Signature

::: vex.Signature

---

## Code

::: vex.Code

---

## Message Link

::: vex.MessageLink

---

## Serial Link

::: vex.SerialLink

---

## Addressable LED

::: vex.AddressableLed

---
